/*******************************************
***** ILP1 formulation  (Open source) *****
********************************************/


#include <vector>
#include <sstream>
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <string.h>
#include <math.h>

using namespace std;

int combi(int n, int r);
int load_data(vector<vector<int> >&pdata, int STEP);

/* main() is the main function */
int main( int argc, char *argv[] )
{	
	int n, r, i, j, l, k, nobs, comb, number, step, flag;
	int count=0, sum_c = 0;
	int COMPLEX_NUM;                         /* Total number of protein complexes */
	int PROTEIN_NUM; 								   /* Total number of proteins */
    vector<int> c;                                   /* All possible combinations of protein pairs for one protein complex */
	vector<int> STEP;                             /* Enough steps  */
	vector<int> num;
	vector<vector<int> > p;                    /* Protein number matrix */  

	int trr = atoi(argv[1]);                      /* Convert the command line argument */
	PROTEIN_NUM = load_data( p, trr );       /* Maximum (Total ) number of proteins */
 	COMPLEX_NUM = p.size();               /*Total number of protein complexes */    
	printf("PROTEIN_NUM=%d, COMPLEX_NUM=%d\n",PROTEIN_NUM,COMPLEX_NUM);

	int a[PROTEIN_NUM][PROTEIN_NUM];
	int a1[COMPLEX_NUM][PROTEIN_NUM][PROTEIN_NUM];
	int b[COMPLEX_NUM][PROTEIN_NUM][PROTEIN_NUM][10];      
		
	for( int i = 0; i < p.size(); ++i ){
			num.push_back( p[i].size() );
	}
	int** data;
	data = (int**)malloc(sizeof(int*)*COMPLEX_NUM);
	for( int i = 0; i < COMPLEX_NUM; i++ ){
		data[i] = (int*)malloc(sizeof(int)*num[i]);
		for( int j = 0; j < num[i]; j++ ){
				data[i][j] = p[i][j];
		}
	}
	/* Create the LP-format file */
	char filename[20];
	sprintf(filename, "dataILP_%d.lp", trr);     
	ofstream  ofs( filename );
	ofs << endl;
	ofs << "Minimize" << endl;
	
	ofs << "\t" << "Value: ";
	for( n = 0; n < COMPLEX_NUM; n++ ){
	    number = p[n].size();
	    comb = combi( number, 2 );            /* Compute all possible combinations of PPIs */
		 c.push_back( comb );
	    STEP.push_back((int)ceil( log2( number )));     
	    sum_c += c[n];
	}

	for( i = 0; i <= PROTEIN_NUM; i++ ){
	    for( j = i+1; j <= PROTEIN_NUM; j++ ){
					a[i][j] = 0;
	    }
	}
	for( n = 0; n < COMPLEX_NUM; n++ ){ 
	   /* Write the objective function to the LP-format file */
	   int m = 0;
	   int m1 = m;
     for( i = 1; i <= PROTEIN_NUM; i++ ){
	      if( i == p[n][m] && m < num[n] ){
	      		for( j = i+1; j <= PROTEIN_NUM; j++ ){
		         		m1 += 1;
	            		if( j == p[n][m1] && m1 < num[n] ){
			 						if( a[i][j] == 0 ){
											ofs << "y" << i << "a" << j;
			 						}
		   				}else{
									m1--;
		 							continue;
		   				}
		   		    count++;
		 			if( count == sum_c ){
							ofs << "\n" << endl;
	    	  				break;
		 			}else{
		    				if( a[i][j] == 0 ){
									ofs << "+";
		        					a[i][j] = 1;
	       		     }  
 	     			 }
	     		}
	     }else{
					continue;
	     }
	   		 m++;
	    		 m1=m;
	   } 
  }

	int counter1 = 0;     
	for( n = 0; n < COMPLEX_NUM; n++ ){ 
	  for( i = 0; i <= PROTEIN_NUM; i++ ){
	     for( j = i+1; j <= PROTEIN_NUM; j++ ){
			      a1[n][i][j] = 0;
	      }
   	}
   }
 /* Write all constraints to the LP-format file */
	ofs <<  "Subject To" << endl;
	for(n = 0; n < COMPLEX_NUM; n++){ 
	   int m = 0;
	   int m1 = m;
     for(i = 1; i <= PROTEIN_NUM; i++ ){
	      	if( i == p[n][m] ){
	      			for( j = i+1; j <= PROTEIN_NUM; j++ ){
		          			m1 += 1;
	             			if( j == p[n][m1] ){
										if( a1[n][i][j] == 0 ){
			      							counter1++;
												ofs << "\t" << "constraint" << counter1 << ": ";
		        								//fprintf(file,"\tconstraint%d: ",counter1);
												ofs << "xc" << n << "a" << i << "a" << j << "a" << STEP[n]	<<  " = 1" << endl;
	          								//fprintf(file,"xc%da%da%da%d = 1\n",n,i,j,STEP[n]); 
			      							a1[n][i][j] = 1;
										}
		     				}else{
			  					 m1--;
		 	  					 continue;
		     			}
 	           }
	      }else{
						continue;
	      }
	    m++;
	    m1=m;
	   } 
   }   	

	for( n = 0; n < COMPLEX_NUM; n++ ){	
		for( i = 0; i <= PROTEIN_NUM; i++ ){
		    for( j = i+1; j <= PROTEIN_NUM; j++ ){
						a1[n][i][j] = 0;
	       }
	   }
	}
	for(n = 0; n < COMPLEX_NUM; n++){ 
	   int m = 0;
	   int m1 = m;
    	 for(i = 1; i <= PROTEIN_NUM; i++ ){
	     	 if( i == p[n][m] && m < num[n] ){
	      		for( j = i+1; j <= PROTEIN_NUM; j++ ){
		     				m1 += 1;
	            	 	if( j == p[n][m1] && m1 < num[n] ){
									if( a1[n][i][j] == 0 ){
			    							counter1++;
											ofs << "\t" << "constraint" << counter1 << ": " ;
		     	 						 //fprintf(file,"\tconstraint%d: ",counter1);
										 ofs << "xc" << n << "a" << i << "a" << j << "a" << "0" << " - y" << i << "a" << j << " <= 0" << endl;
	       							//fprintf(file,"xc%da%da%da%d - y%da%d <= 0\n",n,i,j,0,i,j);
          								a1[n][i][j] = 1;
							  		}
		     				}else{
			  						m1--;
		 	  						continue;
		    		 		}
 	       	 }
	      }else{
					continue;
	      }
	    			m++;
	   		   m1=m;
	   } 
   }

	for(n = 0; n < COMPLEX_NUM; n++){ 
	  for( step = 0; step < STEP[n]; step++ ){ 
	    for( i = 0; i <= PROTEIN_NUM; i++ ){
	        for( j = i+1; j <= PROTEIN_NUM; j++ ){
		    			  b[n][i][j][step] = 0;
	        }
	    }
	  }
	}	
	for(n = 0; n < COMPLEX_NUM; n++){
	 	for( step = 0; step < STEP[n]; step++ ){ 
	  			 int m = 0;
	   		 int m1 = m;
    	 		 for(i = 1; i <= PROTEIN_NUM; i++ ){
	                  if( i == data[n][m] ){
	      	            	for( j = i+1; j <= PROTEIN_NUM; j++ ){
		           						m1 += 1;
	            						 if( j == data[n][m1] ){
														if( b[n][i][j][step] == 0 ){
																	counter1++;
																	ofs << "\t" << "constraint" << counter1 << ": " ;
																	//fprintf(file,"\tconstraint%d: ",counter1);
																	//printf("xc%da%da%da%d - ",n,i,j,step+1);
																	ofs << "xc" << n << "a" << i << "a" << j << "a" << step+1 << " - ";
																	//fprintf(file,"xc%da%da%da%d - ",n,i,j,step+1);
			  														for( l = 0; l < num[n]; l++ ){
		       	     				 								  if( data[n][l] != i && data[n][l] != j ){
			        							 								//	printf("data[%d][%d]=%d\n",n,l,data[n][l]);
			        							 									k = data[n][l];
												 							//		printf("xc%da%da%da%da%d - ",n,i,j,k,step+1);
																					ofs << "xc" << n << "a" << i << "a" << j << "a" << k << "a" <<  step+1 << " - ";
												 									//fprintf(file,"xc%da%da%da%da%d - ",n,i,j,k,step+1);
										 							 	}
																 }
															 	ofs << "xc" << n << "a" << i << "a" << j << "a" << step << " <= 0 " << endl;
	                      								        //fprintf(file,"xc%da%da%da%d <= 0\n",n,i,j,step);
			 					 							 	b[n][i][j][step] = 1;
													}
		     							}else{
			  										m1--;
		 	  										continue;
		     							}	
 	      					}
	     				}else{
									continue;
	    		 		  }
	   		 m++;
	   		m1=m;
	   }
	  }
  }   	

	for(n = 0; n < COMPLEX_NUM; n++){ 
	 for( step = 0; step < STEP[n]; step++ ){ 
	    for( i = 0; i <= PROTEIN_NUM; i++ ){
	        for( j = i+1; j <= PROTEIN_NUM; j++ ){
		    			b[n][i][j][step] = 0;
	        }
	    }
	  }
	}    	
	for(n = 0; n < COMPLEX_NUM; n++){ 
	 for( step = 0; step < STEP[n]; step++ ){ 
	   int m = 0;
	   int m1 = m;
     for(i = 1; i <= PROTEIN_NUM; i++ ){
	      if( i == data[n][m] ){
	      	 for( j = i+1; j <= PROTEIN_NUM; j++ ){
		           m1 += 1;
	              if( j == data[n][m1] ){
								if( b[n][i][j][step] == 0 ){
			 						for( l = 0; l < num[n]; l++ ){
		       	   				if( data[n][l] != i && data[n][l] != j ){
			      						k = data[n][l];
		        					  	 	counter1++;
										   ofs << "\t" << "constraint" << counter1 << ": " ;
		        				     		// fprintf(file,"\tconstraint%d: ",counter1);
										  /* Classify the case according to the number of i, j, k */  
		        							if( i < k && j < k ){     
												ofs << "2xc" << n << "a" << i << "a" << j << "a" << k << "a" << step+1 << " - " 
												<< "xc" << n << "a" << i << "a" << k << "a" << step << " - " 
												<< "xc" << n << "a" << j << "a" << k  << "a" << step << " <= 0" << endl;
		       	  					  	//		 printf("2xc%da%da%da%da%d - xc%da%da%da%d - xc%da%da%da%d <= 0\n",n,i,j,k,step+1,n,i,k,step,n,j,k,step);  
	               	  		     	//		 fprintf(file,"2xc%da%da%da%da%d - xc%da%da%da%d - xc%da%da%da%d <= 0\n",n,i,j,k,step+1,n,i,k,step,n,j,k,step); 
		        							}else if( i < k && j > k ){
												ofs << "2xc" << n << "a" << i << "a" << j << "a" << k << "a" << step+1 << " - " 
												<< "xc" << n << "a" << i << "a" << k << "a" << step << " - " 
												<< "xc" << n << "a" << k << "a" << j  << "a" << step << " <= 0" << endl;
			   						   //		printf("2xc%da%da%da%da%d - xc%da%da%da%d - xc%da%da%da%d <= 0\n",n,i,j,k,step+1,n,i,k,step,n,k,j,step,n,i,j,k,step);
	               	 		     	//	   fprintf(file,"2xc%da%da%da%da%d - xc%da%da%da%d - xc%da%da%da%d <= 0\n",n,i,j,k,step+1,n,i,k,step,n,k,j,step);
		          			  			}else if( i > k && j > k ){
												ofs << "2xc" << n << "a" << i << "a" << j << "a" << k << "a" << step+1 << " - " 
												<< "xc" << n << "a" << k << "a" << i << "a" << step << " - " 
												<< "xc" << n << "a" << k << "a" << j  << "a" << step << " <= 0" << endl;
			    							//		printf("2xc%da%da%da%da%d - xc%da%da%da%d - xc%da%da%da%d <= 0\n",n,i,j,k,step+1,n,k,i,step,n,k,j,step);
	               	  		     	//	   fprintf(file,"2xc%da%da%da%da%d - xc%da%da%da%d - xc%da%da%da%d <= 0\n",n,i,j,k,step+1,n,k,i,step,n,k,j,step);
		           		        	 }
		       			 			      b[n][i][j][step] = 1;	
										}
								 }
		           }    
		     }else{
			  			m1--;
		 	  			continue;
		     }
 	      }
	     }else{
		      continue;
	    }
	        m++;
	        m1=m;
	   } 
	  }
   }   	

    
   /* Write a variable which takes 0 or 1 */
	ofs << endl;
	ofs << "Binary" << endl;
	
	for( i = 0; i <= PROTEIN_NUM; i++ ){
	    for( j = i+1; j <= PROTEIN_NUM; j++ ){
				  a[i][j] = 0;
	    }
	}
	for(n = 0; n < COMPLEX_NUM; n++){ 
	   int m = 0;
	   int m1 = m;
       for(i = 1; i <= PROTEIN_NUM; i++ ){
	     		 if( i == data[n][m] ){
	      			for( j = i+1; j <= PROTEIN_NUM; j++ ){
		     				 m1 += 1;
	             		 if( j == data[n][m1] ){
		      					 if( a[i][j] == 0 ){
											ofs << "\t" << "y" << i << "a" << j << endl;
	         	 						    //printf("y%da%d\n",i,j);
	          						       //fprintf(file,"\ty%da%d\n",i,j);
			 								 a[i][j] = 1;
									}
		    				 }else{
			  						m1--;
		 						   continue;
		              }
 	             }
	          }else{
		             continue;
	         }
	          m++;
	          m1=m;
	     } 
    }
	
	for(n = 0; n < COMPLEX_NUM; n++){ 
	 for( step = 0; step <= STEP[n]; step++ ){ 
	    for( i = 0; i <= PROTEIN_NUM; i++ ){
	        for( j = i+1; j <= PROTEIN_NUM; j++ ){
		    			b[n][i][j][step] = 0;
	        }
	    }
	  }
	}    	
  for(n = 0; n < COMPLEX_NUM; n++){ 
     for( step = 0; step <= STEP[n]; step++ ){ 
	   int m = 0;
	   int m1 = m;
    	for(i = 1; i <= PROTEIN_NUM; i++ ){
	       	if( i == data[n][m] ){
	      	   for( j = i+1; j <= PROTEIN_NUM; j++ ){
		             m1 += 1;
	                if( j == data[n][m1] ){
		                     if( b[n][i][j][step] == 0 ){
											ofs << "\t" << "xc" << n << "a" << i << "a" << j << "a" << step << endl;
	              	              //printf("xc%da%da%da%d\n",n,i,j,step);
	                   			 // fprintf(file,"\txc%da%da%da%d\n",n,i,j,step);
			              				 b[n][i][j][step] = 1;
		           				 }
		     			}else{
			       			m1--;
		 	       			continue;
		     			}
 	        		}
	      	}else{
		      		continue;
	      	}
	    	m++;
	    	m1=m;
	   } 
     }
   }
	
  for(n = 0; n < COMPLEX_NUM; n++){
	 for( step = 0; step <= STEP[n]; step++ ){ 
	    for( i = 0; i <= PROTEIN_NUM; i++ ){
	        for( j = i+1; j <= PROTEIN_NUM; j++ ){
		   			b[n][i][j][step] = 0;
	        }
	    }
	  }
	}    	
   for(n = 0; n < COMPLEX_NUM; n++){ 
     	for( step = 1; step <= STEP[n]; step++ ){ 
	  	 int m = 0;
	     int m1 = m;
   	  for(i = 1; i <= PROTEIN_NUM; i++ ){
	        if( i == data[n][m] ){
	      	   for( j = i+1; j <= PROTEIN_NUM; j++ ){
		            m1 += 1;
	                if( j == data[n][m1] ){
		                  if( b[n][i][j][step] == 0 ){
	         	             for( l = 0; l < num[n]; l++ ){
		                          if( data[n][l] != i && data[n][l] != j ){
			                           k = data[n][l];
												ofs << "\t" << "xc" << n << "a" << i << "a" << j <<"a" << k << "a" << step << endl;
			                    			//fprintf(file,"\txc%da%da%da%da%d\n",n,i,j,k,step);
		                  			}
		               		}     
						      			b[n][i][j][step] = 1;
		           			}		
		        		}else{
			         		 m1--;
		 	        			 continue;
		        		}
 	             }
	        }else{
		            continue;
	      }
	       m++;
	       m1=m;
	   } 
    }
  }
      
	for( int i = 0; i < COMPLEX_NUM; ++i ){	
			free( data[i] );                           
	 }
		free( data );                  

		ofs << endl;
		ofs << "End" << endl;
		printf("dataILP_%d.lp is created !\n", trr);
 
	return 0;
}

/*  combi() calculates the number of all possible combinations of two protein pairs */
/*  n : the total number of proteins in one protein complex */
/*  r : two proteins */
/*  Return value : the number of all possible combinations */ 
int  combi(int n, int r)
{
    int i, p = 1;
    for( i = 1; i <= r; i++ ){
        	p = p * ( n - i + 1) / i;
	 }
    return p;
}	

/* load_data() reads a tab-delimited protein complex dataset into matrix pdata */ 
/* pdata : protein number matrix which is initially empty */
/* trr : the number of corresponding protein complex data */ 
/* Return value : the maximum number of proteins in the protein complex dataset */ 
int  load_data(vector<vector<int> >& pdata, int trr )
{
	char dataname[20];
	sprintf(dataname, "syndata_%d.txt", trr);     
	ifstream fs(dataname);                   
	string line;

	int max = 0;
	while (getline(fs, line, '\n')){          					  					
		vector<int> ldata;                             /* read one line into matrix ldata */ 
		istringstream ss(line);														
		string s;
		while (getline(ss, s, '	')){               /* read tab-delimited strings into the string s */
				istringstream is(s);
				int xs;
				is >> xs;
				xs = atoi(s.c_str());						  /* convert the string into an integer value */
		   	ldata.push_back(xs);                 /* push back the integer value to the vector  */	
				if( max < xs ){                            /*  update the maximum number of proteins if it is larger than current max */
					 max = xs;            
				}	
		}
				pdata.push_back(ldata);                       
 	}
	return max;

}

